//+-------------------------------------------------------------------------------------------------+
//|																						Sessions.mq4|
//+-------------------------------------------------------------------------------------------------+
#property	indicator_chart_window
#define		OneDayInSeconds						86400	// 60*60*24
#define		OneHourInSeconds					3600	// 60*60
#define		OneSessionInSeconds					32400	// 60*60*9									
extern		int			eiNumberOfDays		= 	07;		// Number Of Days to Draw rectancle
extern		int			eiBrokerHHOffset	=	03;		// Broker Offset (FXDD)
extern		color		ecSydneyColor		=	Khaki;
extern		color		ecTokyoColor		=	Magenta;
extern		color		ecLondonColor		=	Orange;
extern		color		ecNewYorkColor		=	Blue;
extern		color		ecColorFont			= 	Black;	// Text font Color
extern		int			eiLineWidth			=	1;		// Rectangle Line Width
extern		int			eiSizeFont			= 	8;		// Text Font Size

			int
				iCountedBars		=	0,
				iSessionBegin[]		=	{	00,			02,			10,			15};
				
			string
				sRoot				=	"!Sessions.",
				sSessionName[]		=	{	"Sydney",	" Tokyo",	" London",	" New York"};
				
			color
				cSessionColor[]		=	{	Khaki,		Magenta,	Orange,		Blue};

			datetime
				tClockTime,
				tToday;
							

//+-------------------------------------------------------------------------------------------------+
//| Custom indicator initialization function														|
//+-------------------------------------------------------------------------------------------------+

void init()
   {
   		tClockTime	=	theTime();
		deleteSessionObjects();

		for(int o=0;o<4;o++)
   			iSessionBegin[o]+=eiBrokerHHOffset-3;
		cSessionColor[0]	=	ecSydneyColor;
		cSessionColor[1]	=	ecTokyoColor;
		cSessionColor[2]	=	ecLondonColor;
		cSessionColor[3]	=	ecNewYorkColor;
		datetime	dt		=	tClockTime;	
		for (int iDayNo=0; iDayNo<eiNumberOfDays; iDayNo++)
			{
				string	sDate	=	TimeToStr(dt,TIME_DATE)+".";
				for(int iSession=0; iSession<4; iSession++)
					if (TimeDayOfWeek(dt)%6!=0)
						{
							string			sObjectName	=	sRoot+sDate+(iSession);
							
							ObjectCreate(	sObjectName, OBJ_RECTANGLE,	0, 0,0, 0,0);
							ObjectSet	(	sObjectName, OBJPROP_STYLE,	STYLE_SOLID);
							ObjectSet	(	sObjectName, OBJPROP_WIDTH,	eiLineWidth);
							ObjectSet	(	sObjectName, OBJPROP_COLOR,	cSessionColor[iSession]);
							ObjectSet	(	sObjectName, OBJPROP_BACK,	false); // true for fill with color
							ObjectSetText(	sObjectName,sSessionName[iSession]);
						}
				dt	-=	OneDayInSeconds;
			}
	}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
void deinit()
	{
		deleteSessionObjects();
	}

void deleteSessionObjects()
	{
		for (int i=ObjectsTotal(); i>=0;i--)
			if(StringSubstr(ObjectName(i),0,StringLen(sRoot))==sRoot)
				ObjectDelete(ObjectName	(i));
	}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
void start()
	{
		if (Period() >	60)
			return(0);
		if(Bars==iCountedBars)
			return(0);
		iCountedBars	=	Bars;
		tClockTime	=	theTime();
		
		if (TimeToStr(tClockTime,TIME_DATE)	!=	TimeToStr(tToday,TIME_DATE))
			{
				tToday	=	tClockTime;
				init();
			}	

		datetime	dt	=	StrToTime(TimeToStr(tClockTime,TIME_DATE))+OneDayInSeconds;
		for (int iDayNo=0; iDayNo<eiNumberOfDays; iDayNo++)
			{
				for(int iSession=0; iSession<4; iSession++)
					drawSession(dt, iSession);
				dt-=OneDayInSeconds;
			}
			
	}

void drawSession(datetime dt, int iSession)
	{
		datetime tBegin, tEnd;
		double   p1, p2;
		int      b1, b2;
					
		string	sDate	=	TimeToStr(dt,TIME_DATE)+".";
		if (TimeDayOfWeek(dt)%6==0)
			return;

		string		sObjectName	=	sRoot+sDate+(iSession);

		tBegin	=	StrToTime(TimeToStr(dt,TIME_DATE))
				+	iSessionBegin[iSession]*OneHourInSeconds;

		tEnd	=	tBegin+OneSessionInSeconds;

		b1=iBarShift(NULL, 0, tBegin);
		b2=iBarShift(NULL, 0, tEnd);
		p1=High[Highest(NULL, 0, MODE_HIGH, b1-b2, b2)];
		p2=Low [Lowest (NULL, 0, MODE_LOW , b1-b2, b2)];
/*
		double dFrame	=	(WindowPriceMax()-WindowPriceMin())/30;
		p1=WindowPriceMax()-dFrame;
		p2=WindowPriceMin()+dFrame;
		if (iSession%2	==	0)
			{
				p1-=1.2*dFrame;
				p2-=dFrame;
			}
*/
		ObjectSet(sObjectName, OBJPROP_TIME1 , tBegin);
		ObjectSet(sObjectName, OBJPROP_PRICE1, p1);
		ObjectSet(sObjectName, OBJPROP_BACK, false); // true for fill with color

		ObjectSet(sObjectName, OBJPROP_TIME2 , tEnd);
		ObjectSet(sObjectName, OBJPROP_PRICE2, p2);

	}

bool Testing()
	{
		return(GlobalVariableCheck("theTime"));
	}
	
datetime theTime()
	{
		if (Testing())
			return(GlobalVariableGet("theTime"));
		return(TimeCurrent());
	}

//+-------------------------------------------------------------------------------------------------+

